/**
 * @file
 * JS implementation for extending the display of imagepin widgets with the Slick carousel.
 */

(function ($, Drupal, window) {
  Drupal.imagepin = Drupal.imagepin || {};
  Drupal.imagepin.extensions = Drupal.imagepin.extensions || {};

  $(window).resize(function () {
    $('.imagepin-widgets').each(function () {
      var attach_id = $(this).attr('data-imagepin-attach-to');
      var image = $("img[data-imagepin-attach-from='" + attach_id + "']");
      $(this).css('max-width', image.width());
    });
  });

  /**
   * Initialize / Uninitialize the slick extension for imagepin widgets.
   */
  Drupal.imagepin.extensions.slick = {
    attach: function (context, settings) {
      $('.imagepin-widgets').each(function () {
        if (!$(this).hasClass('slick-slider')) {
          var attach_id = $(this).attr('data-imagepin-attach-to');

          $(this).on('init', function (slick) {
            $('.imagepin-widget', $(this)).each(function () {
              var key = $(this).attr('data-imagepin-key');
              var slick_index = $(this).attr('data-slick-index');
              var pin = $(".imagepin[data-imagepin-key='" + key + "'][data-imagepin-attached-to='" + attach_id + "']");
              pin.attr('data-imagepin-slide', slick_index);
              pin.on('mouseover touchstart', function () {
                var original_slide = $(".slick-slide[data-imagepin-key='" + key + "']:not(.slick-cloned)");
                var slide = original_slide.length > 0 ? original_slide.first() : $(".slick-slide[data-imagepin-key='" + key + "']").first();
                if (!slide.hasClass('slick-current')) {
                  $('.imagepin-widget.imagepin-selected').removeClass('imagepin-selected');
                  slide.click();
                }
              });
            });
            var first_slide = $('.slick-current').first();
            var first_key = first_slide.attr('data-imagepin-key');
            $(".imagepin[data-imagepin-key='" + first_key + "'][data-imagepin-attached-to='" + attach_id + "']").addClass('imagepin-selected');
          });

          $(this).slick({
            infinite: true,
            centerMode: true,
            focusOnSelect: true,
            variableWidth: true,
            arrows: false,
            speed: 700
          });

          $(this).on('afterChange', function (event, slick, currentSlide) {
            var slide = $(slick.$slides.get(currentSlide));
            var key = slide.attr('data-imagepin-key');
            $('.imagepin-selected').removeClass('imagepin-selected');
            slide.addClass('imagepin-selected');
            $(".imagepin[data-imagepin-key='" + key + "']").addClass('imagepin-selected');
          });
        }
      });
    },
    detach: function (context, settings) {}
  };
}(jQuery, Drupal, window));
